Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/commands/function/WordPropertiesFromTable.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/commands/function/WordPropertiesFromTable.java	(revision 0)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/commands/function/WordPropertiesFromTable.java	(revision 3422)
@@ -0,0 +1,26 @@
+package org.txm.rcp.commands.function;
+
+import java.io.File;
+
+import org.eclipse.core.commands.AbstractHandler;
+import org.eclipse.core.commands.ExecutionEvent;
+import org.eclipse.core.commands.ExecutionException;
+import org.eclipse.jface.viewers.IStructuredSelection;
+import org.eclipse.ui.IWorkbenchPart;
+import org.eclipse.ui.handlers.HandlerUtil;
+import org.txm.Toolbox;
+import org.txm.rcp.handlers.scripts.ExecuteGroovyMacro;
+
+public class WordPropertiesFromTable extends AbstractHandler{
+
+	@Override
+	public Object execute(ExecutionEvent event) throws ExecutionException {
+		IWorkbenchPart part = HandlerUtil.getActivePart(event);
+		IStructuredSelection selection = HandlerUtil.getCurrentStructuredSelection(event);
+		
+		File script = new File(Toolbox.getTxmHomePath(), "/scripts/groovy/user/org/txm/macro/annotation/ImportWordPropertiesFromTableMacro.groovy");
+		ExecuteGroovyMacro.execute(script.getAbsolutePath(), part, selection, "");
+		return null;
+	}
+	
+}

Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/commands/OpenWelcomePage.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/commands/OpenWelcomePage.java	(revision 3421)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/commands/OpenWelcomePage.java	(revision 3422)
@@ -45,7 +45,7 @@
 	/** The Constant ID. */
 	public final static String ID = "org.txm.rcp.commands.OpenWelcomePage"; //$NON-NLS-1$
 	
-	public static String WELCOME = "https://pages.textometrie.org/textometrie/files/software/TXM/";
+	public static String WELCOME = "https://pages.textometrie.org/textometrie/files/software/TXM/"; //$NON-NLS-1$
 	
 	/*
 	 * (non-Javadoc)
@@ -63,13 +63,11 @@
 		int idx = version.lastIndexOf("."); //$NON-NLS-1$
 		if (idx > 0) version = version.substring(0, idx); // remove the "qualifier" part
 		
-		// version += "beta";
-		
 		if ("fr".equals(locale)) {
-			return OpenBrowser.openfile(WELCOME + version + "/welcome") != null;
+			return OpenBrowser.openfile(WELCOME + version + "/welcome") != null; //$NON-NLS-1$ $NON-NLS-2$
 		}
 		else {
-			return OpenBrowser.openfile(OpenLocalizedWebPage.getValidURL(WELCOME + version + "/" + locale + "/welcome", (WELCOME + version + "/welcome"))) != null;
+			return OpenBrowser.openfile(OpenLocalizedWebPage.getValidURL(WELCOME + version + "/" + locale + "/welcome", (WELCOME + version + "/welcome"))) != null; //$NON-NLS-1$ $NON-NLS-2$ $NON-NLS-3$
 		}
 	}
 }
Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/commands/ShowSelected.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/commands/ShowSelected.java	(revision 3421)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/commands/ShowSelected.java	(revision 3422)
@@ -66,4 +66,24 @@
 		}
 		return null;
 	}
+	
+	public static void print(IStructuredSelection structSelection) {
+		if (structSelection == null) System.out.println("no selection.");
+		
+		for (Object elem : structSelection.toList()) {
+			print(elem);
+		}
+	}
+	
+	public static void print(Object elem) {
+		if (elem instanceof File) {
+			File f = (File)elem;
+			System.out.println(TXMUIMessages.fileColon);
+			System.out.println(" path="+f.getAbsolutePath());
+			System.out.println(" size="+f.length()/1000+" kb");
+			System.out.println(" rights: read="+f.canRead()+" write="+f.canWrite()+" execute="+f.canExecute());
+		} else {
+			System.out.println(elem);
+		}
+	}
 }
\ No newline at end of file
Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/ApplicationWorkbenchWindowAdvisor.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/ApplicationWorkbenchWindowAdvisor.java	(revision 3421)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/ApplicationWorkbenchWindowAdvisor.java	(revision 3422)
@@ -27,8 +27,11 @@
 //
 package org.txm.rcp;
 
+import java.util.ArrayList;
+import java.util.HashMap;
 import java.util.Iterator;
 
+import org.apache.commons.lang.StringUtils;
 import org.eclipse.e4.ui.model.application.ui.SideValue;
 import org.eclipse.e4.ui.model.application.ui.basic.MTrimBar;
 import org.eclipse.e4.ui.model.application.ui.basic.MTrimElement;
@@ -38,14 +41,20 @@
 import org.eclipse.e4.ui.workbench.modeling.EModelService;
 import org.eclipse.jface.action.IContributionItem;
 import org.eclipse.jface.action.IMenuManager;
+import org.eclipse.jface.dialogs.MessageDialog;
 import org.eclipse.swt.graphics.Point;
-import org.eclipse.swt.widgets.Shell;
 import org.eclipse.ui.IWorkbenchPage;
 import org.eclipse.ui.IWorkbenchWindow;
 import org.eclipse.ui.PlatformUI;
 import org.eclipse.ui.application.IWorkbenchWindowConfigurer;
+import org.eclipse.ui.application.WorkbenchAdvisor;
 import org.eclipse.ui.application.WorkbenchWindowAdvisor;
 import org.eclipse.ui.internal.WorkbenchWindow;
+import org.txm.Toolbox;
+import org.txm.annotation.core.AnnotationEngine;
+import org.txm.annotation.core.AnnotationEnginesManager;
+import org.txm.core.engines.EngineType;
+import org.txm.objects.CorpusBuild;
 import org.txm.rcp.messages.TXMUIMessages;
 import org.txm.utils.logger.Log;
 
@@ -156,4 +165,31 @@
 		// }
 		// }
 	}
+	
+    /**
+	 * Check if some annotations are not saved and ask the user if he really wish to close TXM.
+	 *
+	 * @return <code>true</code> to allow the window to close, and
+	 *         <code>false</code> if some annotations are not saved and the user wants to save them before
+	 * @see org.eclipse.ui.IWorkbenchWindow#close
+	 * @see WorkbenchAdvisor#preShutdown()
+	 */
+	public boolean preWindowShellClose() {
+		AnnotationEnginesManager aem = (AnnotationEnginesManager) Toolbox.getEngineManager(EngineType.ANNOTATION);
+		HashMap<CorpusBuild, ArrayList<AnnotationEngine>> notSaved = aem.getEnginesWithSaveNeededPerCorpus();
+		if (notSaved.size() > 0) {
+			StringBuilder mess = new StringBuilder();
+			mess.append( "Some annotations are not saved for corpus and engines:");
+			for (CorpusBuild corpus : notSaved.keySet())  {
+				mess.append("\n- "+corpus+":");
+				for (AnnotationEngine a: notSaved.get(corpus)) {
+					mess.append("\n  - "+a.getName());
+				}
+			}
+			mess.append("\n\nContinue and lost the unsaved annotations ?");
+			return MessageDialog.openConfirm(this.getWindowConfigurer().getWindow().getShell(), "Some annotations are not saved", mess.toString());
+		} else {
+			return true;
+		}
+	}
 }
Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/editors/imports/sections/TextualPlansSection.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/editors/imports/sections/TextualPlansSection.java	(revision 3421)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/editors/imports/sections/TextualPlansSection.java	(revision 3422)
@@ -23,12 +23,6 @@
 	
 	private Text outsideTextElementsToEditText;
 	
-	private Text noteElementsText;
-	
-	private Text milestoneElementsText;
-
-	private Text projectionsText;
-	
 	public TextualPlansSection(ImportFormEditor editor, FormToolkit toolkit2, ScrolledForm form2, Composite parent, int style) {
 		super(editor, toolkit2, form2, parent, style, "textualplans");
 		
@@ -69,33 +63,6 @@
 		gdata = getTextGridData();
 		outsideTextElementsToEditText.setLayoutData(gdata);
 		
-		Label tmpLabel3 = toolkit.createLabel(sectionClient, "Note elements");
-		tmpLabel3.setToolTipText("Note elements that encodes ponctual notes");
-		tmpLabel3.setLayoutData(getLabelGridData());
-		
-		noteElementsText = toolkit.createText(sectionClient, "note", SWT.BORDER); //$NON-NLS-1$
-		gdata = getTextGridData();
-		noteElementsText.setLayoutData(gdata);
-		
-		Label tmpLabel4 = toolkit.createLabel(sectionClient, TXMUIMessages.milestoneElements);
-		tmpLabel4.setToolTipText(TXMUIMessages.listOfMilestoneElementsSeparatedByComma);
-		tmpLabel4.setLayoutData(getLabelGridData());
-		
-		milestoneElementsText = toolkit.createText(sectionClient, "", SWT.BORDER); //$NON-NLS-1$
-		gdata = getTextGridData();
-		milestoneElementsText.setLayoutData(gdata);
-		
-		Label label = toolkit.createLabel(sectionClient, "CQP Structure properties projections", SWT.WRAP);
-		gdata = getLabelGridData();
-		gdata.colspan = 2;
-		label.setLayoutData(gdata);
-		
-		projectionsText = toolkit.createText(sectionClient, "", SWT.BORDER | SWT.MULTI | SWT.V_SCROLL); //$NON-NLS-1$
-		gdata = getTextGridData();
-		gdata.heightHint = 50;
-		gdata.colspan = 2;
-		
-		projectionsText.setLayoutData(gdata);
 	}
 	
 	@Override
@@ -103,9 +70,6 @@
 		if (this.section != null && !section.isDisposed()) {
 			outsideTextElementsText.setText(project.getTextualPlan("OutSideTextTags"));
 			outsideTextElementsToEditText.setText(project.getTextualPlan("OutSideTextTagsAndKeepContent"));
-			noteElementsText.setText(project.getTextualPlan("Note"));
-			milestoneElementsText.setText(project.getTextualPlan("MileStones"));
-			projectionsText.setText(project.getTextualPlan("Projections"));
 		}
 	}
 	
@@ -117,12 +81,6 @@
 			
 			project.setTextualPlan("OutSideTextTagsAndKeepContent", outsideTextElementsToEditText.getText().trim());
 			
-			project.setTextualPlan("Note", noteElementsText.getText());
-			
-			project.setTextualPlan("MileStones", milestoneElementsText.getText().trim());
-			
-			project.setTextualPlan("Projections", projectionsText.getText().trim());
-			
 			return true;
 		}
 		
Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/editors/imports/sections/EditionSection.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/editors/imports/sections/EditionSection.java	(revision 3421)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/editors/imports/sections/EditionSection.java	(revision 3422)
@@ -37,6 +37,8 @@
 	
 	Button collapsibleMetadataDefaultEditionButton;
 	
+	private Text noteElementsText;
+	
 	Text wordsPerPageText;
 	
 	Text pageBreakText;
@@ -128,6 +130,17 @@
 		
 		if (scriptName.startsWith("xtz")) {
 			
+			Label tmpLabel3 = toolkit.createLabel(sectionClient, "Note elements");
+			tmpLabel3.setToolTipText("Note elements that encodes ponctual notes");
+			TableWrapData gdata3 = getLabelGridData();
+			gdata3.indent = 40;
+			tmpLabel3.setLayoutData(gdata3);
+			
+			noteElementsText = toolkit.createText(sectionClient, "note", SWT.BORDER); //$NON-NLS-1$
+			gdata3 = getTextGridData();
+			gdata3.colspan = 3; // one line
+			noteElementsText.setLayoutData(gdata3);
+			
 			// build text edition or not button
 			buildFacsEditionCheckButton = toolkit.createButton(sectionClient, "Build 'facs' edition", SWT.CHECK);
 			buildFacsEditionCheckButton.setSelection(false);
@@ -280,6 +293,8 @@
 			int wppt = edition_params.getWordsPerPage();
 			wordsPerPageText.setText("" + wppt); //$NON-NLS-1$
 			
+			if (noteElementsText != null) noteElementsText.setText(project.getTextualPlan("Note"));
+			
 			String pbt = edition_params.getPageElement();
 			if (pageBreakText != null)
 				pageBreakText.setText(pbt);
@@ -328,6 +343,8 @@
 			edition_params.setPaginateEdition(paginate);
 			edition_params.setEnableCollapsible(collapsible);
 			
+			if (noteElementsText != null) project.setTextualPlan("Note", noteElementsText.getText());
+			
 			if (buildFacsEditionCheckButton != null) {
 				
 				String images_directory = "";
Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/editors/imports/sections/WordsSection.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/editors/imports/sections/WordsSection.java	(revision 0)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/editors/imports/sections/WordsSection.java	(revision 3422)
@@ -0,0 +1,389 @@
+package org.txm.rcp.editors.imports.sections;
+
+import java.util.HashMap;
+
+import org.eclipse.jface.viewers.TableViewer;
+import org.eclipse.swt.SWT;
+import org.eclipse.swt.events.SelectionEvent;
+import org.eclipse.swt.events.SelectionListener;
+import org.eclipse.swt.widgets.Button;
+import org.eclipse.swt.widgets.Composite;
+import org.eclipse.swt.widgets.Label;
+import org.eclipse.swt.widgets.Text;
+import org.eclipse.ui.forms.events.ExpansionAdapter;
+import org.eclipse.ui.forms.events.ExpansionEvent;
+import org.eclipse.ui.forms.widgets.FormToolkit;
+import org.eclipse.ui.forms.widgets.ScrolledForm;
+import org.eclipse.ui.forms.widgets.TableWrapData;
+import org.eclipse.ui.forms.widgets.TableWrapLayout;
+import org.txm.objects.Project;
+import org.txm.rcp.editors.imports.ImportFormEditor;
+import org.txm.rcp.editors.imports.ImportModuleCustomization;
+import org.txm.rcp.messages.TXMUIMessages;
+import org.txm.tokenizer.TTest;
+import org.txm.tokenizer.TokenizerClasses;
+import org.w3c.dom.Element;
+import org.w3c.dom.NodeList;
+
+public class WordsSection extends ImportEditorSection {
+	
+	static final int SECTION_SIZE = 1;
+	
+	Text wordElementText;
+	
+	Button doTokenizeStepButton;
+	
+	Button doRetokenizeStepButton;
+	
+	Button doBuildWordIDsButton;
+	
+	Text textElisions;
+	
+	Text textPuncts;
+	
+	Text textPunctsStrong;
+	
+	Text textWhiteSpaces;
+	
+	Label titleLabel;
+	
+	TableViewer tokenizerParamsViewer;
+	
+	TableViewer tokenizerParamsViewer2;
+	
+	private HashMap<String, Boolean> moduleParams;
+	
+	public WordsSection(ImportFormEditor editor, FormToolkit toolkit2, ScrolledForm form2, Composite parent, int style, HashMap<String, Boolean> moduleParams) {
+		super(editor, toolkit2, form2, parent, style, "words");
+		this.moduleParams = moduleParams;
+		this.section.setText("Words");
+		TableWrapLayout layout = new TableWrapLayout();
+		layout.makeColumnsEqualWidth = true;
+		this.section.setLayout(layout);
+		this.section.setLayoutData(getSectionGridData(SECTION_SIZE));
+		this.section.setEnabled(false);
+		
+		this.section.addExpansionListener(new ExpansionAdapter() {
+			
+			@Override
+			public void expansionStateChanged(ExpansionEvent e) {
+				form.layout(true);
+			}
+		});
+		
+		Composite sectionClient = toolkit.createComposite(this.section);
+		TableWrapLayout slayout = new TableWrapLayout();
+		slayout.makeColumnsEqualWidth = false;
+		slayout.numColumns = 3;
+		sectionClient.setLayout(slayout);
+		this.section.setClient(sectionClient);
+		
+		Label tmpLabel3 = toolkit.createLabel(sectionClient, TXMUIMessages.wordTag);
+		TableWrapData gdata = new TableWrapData(TableWrapData.LEFT, TableWrapData.FILL);
+		gdata.colspan = 2;
+		tmpLabel3.setLayoutData(gdata);
+		tmpLabel3.setToolTipText(TXMUIMessages.xmlTagNameThatEncodesWords);
+		tmpLabel3.setVisible(moduleParams.get(ImportModuleCustomization.ADVANCEDTOKENIZER));
+		
+		wordElementText = toolkit.createText(sectionClient, "w", SWT.BORDER); //$NON-NLS-1$
+		gdata = getTextGridData();
+		wordElementText.setLayoutData(gdata);
+		wordElementText.setVisible(moduleParams.get(ImportModuleCustomization.ADVANCEDTOKENIZER));
+		doTokenizeStepButton = toolkit.createButton(sectionClient, TXMUIMessages.tokenization, SWT.CHECK);
+		doTokenizeStepButton.setSelection(true);
+		doTokenizeStepButton.setVisible(moduleParams.get(ImportModuleCustomization.ADVANCEDTOKENIZER));
+		gdata = new TableWrapData(TableWrapData.LEFT, TableWrapData.FILL);
+		gdata.colspan = 3;
+		doTokenizeStepButton.setLayoutData(gdata);
+		doTokenizeStepButton.addSelectionListener(new SelectionListener() {
+			
+			@Override
+			public void widgetSelected(SelectionEvent e) {
+				updateFieldsEnableState();
+			}
+			
+			@Override
+			public void widgetDefaultSelected(SelectionEvent e) {}
+		});
+		
+		doRetokenizeStepButton = toolkit.createButton(sectionClient, TXMUIMessages.retokenizePreEncodedWords, SWT.CHECK);
+		doRetokenizeStepButton.setToolTipText(TXMUIMessages.performWordSegmentationWithinWord);
+		doRetokenizeStepButton.setSelection(true);
+		doRetokenizeStepButton.setVisible(moduleParams.get(ImportModuleCustomization.ADVANCEDTOKENIZER));
+		gdata = new TableWrapData(TableWrapData.LEFT, TableWrapData.FILL);
+		gdata.indent = 20;
+		gdata.colspan = 3;
+		doRetokenizeStepButton.setLayoutData(gdata);
+		
+		doBuildWordIDsButton = toolkit.createButton(sectionClient, "Build word identifiers", SWT.CHECK);
+		doBuildWordIDsButton.setToolTipText(TXMUIMessages.performWordSegmentationWithinWord);
+		doBuildWordIDsButton.setSelection(true);
+		doBuildWordIDsButton.setVisible(moduleParams.get(ImportModuleCustomization.ADVANCEDTOKENIZER));
+		gdata = new TableWrapData(TableWrapData.LEFT, TableWrapData.FILL);
+		gdata.indent = 20;
+		gdata.colspan = 3;
+		doBuildWordIDsButton.setLayoutData(gdata);
+		
+		Label l0 = toolkit.createLabel(sectionClient, TXMUIMessages.separatorCharacters, SWT.WRAP);
+		gdata = new TableWrapData(TableWrapData.LEFT, TableWrapData.FILL);
+		gdata.colspan = 3;
+		gdata.indent = 20;
+		l0.setLayoutData(gdata);
+		
+		Label l1 = toolkit.createLabel(sectionClient, TXMUIMessages.spaces, SWT.WRAP);
+		gdata = new TableWrapData(TableWrapData.LEFT, TableWrapData.FILL);
+		gdata.colspan = 2;
+		gdata.indent = 40;
+		l1.setLayoutData(gdata);
+		
+		textWhiteSpaces = toolkit.createText(sectionClient, "", SWT.BORDER);
+		gdata = getLongTextGridData();
+		textWhiteSpaces.setLayoutData(gdata);
+		
+		Label l2 = toolkit.createLabel(sectionClient, TXMUIMessages.punctuations, SWT.WRAP);
+		gdata = new TableWrapData(TableWrapData.LEFT, TableWrapData.FILL);
+		gdata.colspan = 2;
+		gdata.indent = 40;
+		l2.setLayoutData(gdata);
+		
+		textPuncts = toolkit.createText(sectionClient, "", SWT.BORDER);
+		gdata = getLongTextGridData();
+		textPuncts.setLayoutData(gdata);
+		
+		Label l4 = toolkit.createLabel(sectionClient, TXMUIMessages.elisionCharacters, SWT.WRAP);
+		gdata = new TableWrapData(TableWrapData.LEFT, TableWrapData.FILL);
+		gdata.colspan = 2;
+		gdata.indent = 20;
+		l4.setLayoutData(gdata);
+		
+		textElisions = toolkit.createText(sectionClient, "", SWT.BORDER);
+		gdata = getLongTextGridData();
+		textElisions.setLayoutData(gdata);
+		
+		Label l3 = toolkit.createLabel(sectionClient, TXMUIMessages.endOfSentenceCharacters, SWT.WRAP);
+		gdata = new TableWrapData(TableWrapData.LEFT, TableWrapData.FILL);
+		gdata.colspan = 2;
+		gdata.indent = 20;
+		l3.setLayoutData(gdata);
+		
+		textPunctsStrong = toolkit.createText(sectionClient, "", SWT.BORDER);
+		gdata = getLongTextGridData();
+		textPunctsStrong.setLayoutData(gdata);
+		
+		Button defaultBtn = toolkit.createButton(sectionClient, TXMUIMessages._default_2, SWT.PUSH);
+		gdata = new TableWrapData(TableWrapData.LEFT, TableWrapData.FILL);
+		gdata.colspan = 2;
+		gdata.indent = 20;
+		defaultBtn.setLayoutData(gdata);
+		defaultBtn.addSelectionListener(new SelectionListener() {
+			
+			@Override
+			public void widgetDefaultSelected(SelectionEvent e) {}
+			
+			@Override
+			public void widgetSelected(SelectionEvent e) {
+				TokenizerClasses tc = new TokenizerClasses(); // use default tokenizer classes
+				textWhiteSpaces.setText(tc.whitespaces);
+				textPuncts.setText(tc.regPunct);
+				textPunctsStrong.setText(tc.punct_strong);
+				textElisions.setText(tc.regElision);
+			}
+		});
+		
+		/*
+		 * setAddSetTestsButton = toolkit.createButton(sectionClient, Messages.CorpusPage_28, SWT.CHECK);
+		 * setAddSetTestsButton.setLayoutData(new GridData(GridData.FILL, GridData.FILL, false, false,4,1));
+		 * // setAddSetTestsButton.setSelection(params.getTokenizerElement(params.getCorpusElement()))
+		 * Button addButton = toolkit.createButton(sectionClient, Messages.CorpusPage_29, SWT.PUSH);
+		 * addButton.setLayoutData(new GridData(GridData.FILL, GridData.FILL, false, false,1,1));
+		 * addButton.addSelectionListener(new SelectionListener() {
+		 * @Override
+		 * public void widgetDefaultSelected(SelectionEvent e) {
+		 * }
+		 * @Override
+		 * public void widgetSelected(SelectionEvent e) {
+		 * if (params == null) return;
+		 * LinkedHashMap<String, String> values = new LinkedHashMap<String, String>();
+		 * values.put("name", ""); //$NON-NLS-1$ //$NON-NLS-2$
+		 * values.put("value", ""); //$NON-NLS-1$ //$NON-NLS-2$
+		 * MultipleValueDialog dlg = new MultipleValueDialog(form.getShell(), Messages.CorpusPage_29, values);
+		 * if (dlg.open() == Window.OK) {
+		 * params.addTokenizerParameter(params.getCorpusElement(), values.get("name"), values.get("value")); //$NON-NLS-1$ //$NON-NLS-2$
+		 * updateTokenizerSection();
+		 * }
+		 * }
+		 * });
+		 * Button removeButton = toolkit.createButton(sectionClient, Messages.CorpusPage_31, SWT.PUSH);
+		 * removeButton.setLayoutData(new GridData(GridData.FILL, GridData.FILL, false, false,1,1));
+		 * removeButton.addSelectionListener(new SelectionListener() {
+		 * @Override
+		 * public void widgetDefaultSelected(SelectionEvent e) {
+		 * }
+		 * @Override
+		 * public void widgetSelected(SelectionEvent e) {
+		 * if (params == null) return;
+		 * ISelection sel = tokenizerParamsViewer.getSelection();
+		 * IStructuredSelection ssel = (IStructuredSelection) sel;
+		 * Object obj = ssel.getFirstElement();
+		 * if (obj instanceof Element) {
+		 * Element query = (Element) obj;
+		 * params.getTokenizerElement(params.getCorpusElement()).removeChild(query);
+		 * updateTokenizerSection();
+		 * }
+		 * }
+		 * });
+		 * Button addButton2 = toolkit.createButton(sectionClient, Messages.CorpusPage_32, SWT.PUSH);
+		 * addButton2.setLayoutData(new GridData(GridData.FILL, GridData.FILL, false, false,1,1));
+		 * addButton2.addSelectionListener(new SelectionListener() {
+		 * @Override
+		 * public void widgetDefaultSelected(SelectionEvent e) {
+		 * }
+		 * @Override
+		 * public void widgetSelected(SelectionEvent e) {
+		 * if (params == null) return;
+		 * LinkedHashMap<String, String> values = new LinkedHashMap<String, String>();
+		 * values.put("value", "\\A(.+)(.+)(.+)\\Z"); //$NON-NLS-1$ //$NON-NLS-2$
+		 * values.put("type", "w"); //$NON-NLS-1$ //$NON-NLS-2$
+		 * values.put("before", "1"); //$NON-NLS-1$ //$NON-NLS-2$
+		 * values.put("hit", "2"); //$NON-NLS-1$ //$NON-NLS-2$
+		 * values.put("after", "3"); //$NON-NLS-1$ //$NON-NLS-2$
+		 * MultipleValueDialog dlg = new MultipleValueDialog(form.getShell(), Messages.CorpusPage_33, values);
+		 * if (dlg.open() == Window.OK) {
+		 * params.addTokenizerTest(params.getCorpusElement(), values.get("value"), values.get("type"), values.get("before"), values.get("hit"), values.get("after")); //$NON-NLS-1$ //$NON-NLS-2$
+		 * //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
+		 * updateTokenizerSection();
+		 * }
+		 * }
+		 * });
+		 * Button removeButton2 = toolkit.createButton(sectionClient, Messages.CorpusPage_34, SWT.PUSH);
+		 * removeButton2.setLayoutData(new GridData(GridData.FILL, GridData.FILL, false, false,1,1));
+		 * removeButton2.addSelectionListener(new SelectionListener() {
+		 * @Override
+		 * public void widgetDefaultSelected(SelectionEvent e) {
+		 * }
+		 * @Override
+		 * public void widgetSelected(SelectionEvent e) {
+		 * if (params == null) return;
+		 * ISelection sel = tokenizerParamsViewer2.getSelection();
+		 * IStructuredSelection ssel = (IStructuredSelection) sel;
+		 * Object obj = ssel.getFirstElement();
+		 * if (obj instanceof Element) {
+		 * Element test = (Element) obj;
+		 * params.getTokenizerElement(params.getCorpusElement()).removeChild(test);
+		 * updateTokenizerSection();
+		 * }
+		 * }
+		 * });
+		 * Table table = toolkit.createTable(sectionClient, SWT.FULL_SELECTION | SWT.MULTI | SWT.V_SCROLL | SWT.VIRTUAL);
+		 * tokenizerParamsViewer = new TableViewer(table);
+		 * tokenizerParamsViewer.getTable().addKeyListener(new TableKeyListener(tokenizerParamsViewer));
+		 * GridData gd = new GridData(GridData.FILL, GridData.FILL, false, false,2,1);
+		 * gd.heightHint = 150;
+		 * tokenizerParamsViewer.getTable().setLayoutData(gd);
+		 * tokenizerParamsViewer.setContentProvider(new NodeListContentProvider());
+		 * tokenizerParamsViewer.getTable().setHeaderVisible(true);
+		 * tokenizerParamsViewer.getTable().setLinesVisible(true);
+		 * String[] cols = {"name", "value"}; //$NON-NLS-1$ //$NON-NLS-2$
+		 * for (String col : cols) {
+		 * TableViewerColumn columnViewer = new TableViewerColumn(tokenizerParamsViewer, SWT.NONE);
+		 * TableColumn column = columnViewer.getColumn();
+		 * column.setText(col);
+		 * column.setWidth(100);
+		 * columnViewer.setLabelProvider(new ElementColumnLabelProvider(col));
+		 * }
+		 * Table table2 = toolkit.createTable(sectionClient, SWT.FULL_SELECTION | SWT.MULTI | SWT.V_SCROLL | SWT.VIRTUAL);
+		 * tokenizerParamsViewer2 = new TableViewer(table2);
+		 * tokenizerParamsViewer2.getTable().addKeyListener(new TableKeyListener(tokenizerParamsViewer2));
+		 * GridData gd2 = new GridData(GridData.FILL, GridData.FILL, false, false,2,1);
+		 * gd.heightHint = 150;
+		 * tokenizerParamsViewer2.getTable().setLayoutData(gd2);
+		 * tokenizerParamsViewer2.setContentProvider(new NodeListContentProvider());
+		 * tokenizerParamsViewer2.getTable().setHeaderVisible(true);
+		 * tokenizerParamsViewer2.getTable().setLinesVisible(true);
+		 * String[] cols2 = {"value", "type", "before", "hit", "after"}; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
+		 * for (String col : cols2) {
+		 * TableViewerColumn columnViewer = new TableViewerColumn(tokenizerParamsViewer2, SWT.NONE);
+		 * TableColumn column = columnViewer.getColumn();
+		 * column.setText(col);
+		 * column.setWidth(100);
+		 * columnViewer.setLabelProvider(new ElementColumnLabelProvider(col));
+		 * }
+		 */
+		
+	}
+	
+	protected void updateFieldsEnableState() {
+		boolean enabled = doTokenizeStepButton.getSelection();
+		doRetokenizeStepButton.setEnabled(enabled);
+		doBuildWordIDsButton.setEnabled(enabled);
+		if (!enabled) {
+			doRetokenizeStepButton.setSelection(false);
+			doBuildWordIDsButton.setSelection(false);
+		}
+		textWhiteSpaces.setEnabled(enabled);
+		textPuncts.setEnabled(enabled);
+		textElisions.setEnabled(enabled);
+		textPunctsStrong.setEnabled(enabled);
+	}
+	
+	@Override
+	public void updateFields(Project project) {
+		if (this.section.isDisposed()) return;
+		if (project == null) return;
+		
+		TokenizerClasses tc = new TokenizerClasses();
+		tc.loadFromProject(project.getPreferencesScope());
+		
+		textWhiteSpaces.setText(project.getTokenizerParameter("whitespaces", tc.whitespaces)); //$NON-NLS-1$
+		textPuncts.setText(project.getTokenizerParameter("regPunct", tc.regPunct)); //$NON-NLS-1$
+		textPunctsStrong.setText(project.getTokenizerParameter("punct_strong", tc.punct_strong)); //$NON-NLS-1$
+		textElisions.setText(project.getTokenizerParameter("regElision", tc.regElision)); //$NON-NLS-1$
+		
+		String wtagElement = project.getTokenizerWordElement();
+		wordElementText.setText(wtagElement);
+		
+		boolean doTokenizeStep = project.getDoTokenizerStep();
+		doTokenizeStepButton.setSelection(doTokenizeStep);
+		boolean doRetokenizeStep = "true".equals(project.getTokenizerParameter("doRetokenizeStep", "false")); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
+		doRetokenizeStepButton.setSelection(doRetokenizeStep);
+		boolean doBuildWordIds = "true".equals(project.getTokenizerParameter("doBuildWordIds", "true")); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
+		doBuildWordIDsButton.setSelection(doBuildWordIds);
+		updateFieldsEnableState();
+		
+		// HashMap<String, TTest> additionalTests = project.getTokenizerAdditionalTests();
+		// try {
+		// setAddSetTestsButton.setSelection(Boolean.parseBoolean(value.toString()));
+		// } catch (Exception e) { };
+	}
+	
+	@Override
+	public boolean saveFields(Project project) {
+		
+		if (textWhiteSpaces.getText().length() == 0 && textPuncts.getText().length() == 0) {
+			System.out.println(TXMUIMessages.errorWhileSavingTokenizerParameters);
+			return false;
+		}
+		project.addTokenizerParameter("whitespaces", textWhiteSpaces.getText()); //$NON-NLS-1$
+		project.addTokenizerParameter("regPunct", textPuncts.getText()); //$NON-NLS-1$
+		project.addTokenizerParameter("punct_strong", textPunctsStrong.getText()); //$NON-NLS-1$
+		project.addTokenizerParameter("regElision", textElisions.getText()); //$NON-NLS-1$
+		project.addTokenizerParameter("word_tags", wordElementText.getText()); //$NON-NLS-1$
+		project.addTokenizerParameter("doTokenizeStep", "" + doTokenizeStepButton.getSelection()); //$NON-NLS-1$ //$NON-NLS-2$
+		project.addTokenizerParameter("doRetokenizeStep", "" + doRetokenizeStepButton.getSelection()); //$NON-NLS-1$ //$NON-NLS-2$
+		project.addTokenizerParameter("doBuildWordIds", "" + doBuildWordIDsButton.getSelection()); //$NON-NLS-1$ //$NON-NLS-2$
+		project.addTokenizerParameter("onlyThoseTests", "false"); //$NON-NLS-1$ //$NON-NLS-2$
+		// project.setTokenizerAdditionalTests(additionalTokenizerTests); //$NON-NLS-1$
+		
+		return true;
+	}
+	
+	@Override
+	public boolean checkFields() {
+		return true;
+	}
+	
+	@Override
+	public int getSectionSize() {
+		return SECTION_SIZE;
+	}
+}

